/*
 * (c) Copyright UVic 2003
 * All Rights Reserved.
 */


function navigate(project, fileName) {
	if (project == null) {
		project = parent.document.GildHiddenForm.CurrentProject.value;
	}
	var url = "" + location;
	var i= url.indexOf("gild_webapp");
	url = url.substring(0, i);
	url = url + "gild_webapp/content?project=" + project + "&file=" + fileName + "&nocaching=" + Math.random();
	//alert(url);
	document.location=url;
	
	//if (parent && parent.ToolbarFrame && parent.ToolbarFrame.liveHelpFrame) {
		//parent.ToolbarFrame.liveHelpFrame.location=url;
	//} else if(parent && parent.ToolbarFrame && parent.ToolbarFrame.document && parent.ToolbarFrame.document.liveHelpFrame){
		//parent.ToolbarFrame.document.liveHelpFrame.src=url;
	//}
}


// for backwards compatability
function liveAction (project, fileName, methodSig) {
	revealInEditor (project, fileName, methodSig);
}

function revealInEditor(project, fileName, methodSig) {
	if (project == null){
		project = parent.document.GildHiddenForm.CurrentProject.value;
	}
	var url = "" + location;
	var i = url.indexOf("gild_webapp");
	var url = url.substring(0, i);
	var args = "project=" + URLEncode(project) + "&fileName=" + URLEncode(fileName);
	if (methodSig != null){
	 args += "&methodSig=" + URLEncode(methodSig);
	}
	args = URLEncode (args);
	url = url + "gild_webapp/command?name=revealInEditor&args=" + args + "&nocaching=" + Math.random();
	//alert(url);
	
	// send the request to the hidden frame
	if (parent && parent.commandFrame){
		parent.commandFrame.location=url; 
	} else if(parent && parent.document && parent.document.commandFrame){
		parent.document.commandFrame.src=url;
	} else {
		alert("commandFrame frame not found in the source page");
	}	
}

function runCode (codeElementID) {
	var elem = getElement(codeElementID);
	if (elem) {
		code = elem.firstChild.nodeValue;
		//alert("original code = " + code);
		
		// construct a url to send to gild web application
		var url = "" + location;
		var i = url.indexOf("gild_webapp");
		url = url.substring(0, i);
		var args = "code=" + URLEncode(code);
		args = URLEncode (args);
		url = url + "gild_webapp/command?name=runCodeSnippet&args=" + args + "&nocaching=" + Math.random();
		//alert("url = " + url);
		
		// send the request to a hidden frame
		if (parent && parent.commandFrame){
			parent.commandFrame.location=url; 
		} else if(parent && parent.document && parent.document.commandFrame){
			parent.document.commandFrame.src=url; 
		} else {
			alert ("commandFrame frame not found in the source page");
		}
    }
}

// gets an element from this document, based on the given id
function getElement(psID) { 
   if(document.all) { 
      return document.all[psID]; 
   } else if(document.getElementById) { 
      return document.getElementById(psID); 
   } else { 
      for (iLayer = 1; iLayer < document.layers.length; iLayer++) { 
         if(document.layers[iLayer].id == psID) 
            return document.layers[iLayer]; 
      }       

   } 

   return null; 
} 
	

// returns the element that the passed in event came from
function getTargetElement(evt) {
	var elem;
	if (evt.target) {
	    elem = evt.target; // other browsers?
	} else {
	    elem = evt.srcElement; // IE compatible
	}
	return elem;	
}


// ====================================================================
//       URLEncode and URLDecode functions
//
// Copyright Albion Research Ltd. 2002
// http://www.albionresearch.com/
//
// You may copy these functions providing that 
// (a) you leave this copyright notice intact, and 
// (b) if you use these functions on a publicly accessible
//     web site you include a credit somewhere on the web site 
//     with a link back to http://www.albionresarch.com/
//
// If you find or fix any bugs, please let us know at albionresearch.com
//
// SpecialThanks to Neelesh Thakur for being the first to
// report a bug in URLDecode() - now fixed 2003-02-19.
// ====================================================================
function URLEncode(plaintext) {
	if (plaintext == null) {
		return "";
	}
	// The Javascript escape and unescape functions do not correspond
	// with what browsers actually do...
	var SAFECHARS = "0123456789" +					// Numeric
					"ABCDEFGHIJKLMNOPQRSTUVWXYZ" +	// Alphabetic
					"abcdefghijklmnopqrstuvwxyz" +
					"-_.!~*'()";					// RFC2396 Mark characters
	var HEX = "0123456789ABCDEF";

	var encoded = "";
	for (var i = 0; i < plaintext.length; i++ ) {
		var ch = plaintext.charAt(i);
	    if (ch == " ") {
		    encoded += "+";				// x-www-urlencoded, rather than %20
		} else if (SAFECHARS.indexOf(ch) != -1) {
		    encoded += ch;
		} else {
		    var charCode = ch.charCodeAt(0);
			if (charCode > 255) {
			    alert( "Unicode Character '" + ch + "' cannot be encoded using standard URL encoding.\n" +
				        "(URL encoding only supports 8-bit characters.)\n" +
						"A space (+) will be substituted." );
				encoded += "+";
			} else {
				encoded += "%";
				encoded += HEX.charAt((charCode >> 4) & 0xF);
				encoded += HEX.charAt(charCode & 0xF);
			}
		}
	} // for

	return encoded;
};

function URLDecode(encoded) {
	if (encoded == null) {
		return "";
	}
   // Replace + with ' '
   // Replace %xx with equivalent character
   // Put [ERROR] in output if %xx is invalid.
   var HEXCHARS = "0123456789ABCDEFabcdef"; 
   var encoded = document.URLForm.F2.value;
   var plaintext = "";
   var i = 0;
   while (i < encoded.length) {
       var ch = encoded.charAt(i);
	   if (ch == "+") {
	       plaintext += " ";
		   i++;
	   } else if (ch == "%") {
			if (i < (encoded.length-2) 
					&& HEXCHARS.indexOf(encoded.charAt(i+1)) != -1 
					&& HEXCHARS.indexOf(encoded.charAt(i+2)) != -1 ) {
				plaintext += unescape( encoded.substr(i,3) );
				i += 3;
			} else {
				alert( 'Bad escape combination near ...' + encoded.substr(i) );
				plaintext += "%[ERROR]";
				i++;
			}
		} else {
		   plaintext += ch;
		   i++;
		}
	} // while
   return plaintext;
};